<?php

$themename = "Snowblind";
$themefile = "snowblind";
$shortname = "sil";

load_theme_textdomain( 'snowblind', TEMPLATEPATH.'/languages' );
 

$options = array (
	
	array(	"name" => __("Site Width", "snowblind"),
			"desc" => __("Select the width of your site.", "snowblind"),
			"id" => $shortname."_site_width",
			"default" => 800,
			"type" => "site"),
			
	array(	"name" => __("Number of Sidebars", "snowblind"),
			"desc" => __("How many sidebars would you like?", "snowblind"),
            "id" => $shortname."_site_sidebars",
			"default" => 1,
            "type" => "sidebars"),
	
	array(  "name" => __("First Sidebar Width", "snowblind"),
			"desc" => __("What would you like your first sidebar width to be?", "snowblind"),
            "id" => $shortname."_sidebar_width1",
			"default" => 180,
            "type" => "left"),
			
	array(  "name" => __("Second Sidebar Width", "snowblind"),
			"desc" => __("What would you like your second sidebar width to be?", "snowblind"),
            "id" => $shortname."_sidebar_width2",
			"default" => 180,
            "type" => "right"),

	array(  "name" => __("Sidebar Location", "snowblind"),
			"desc" => __("Where would you like your sidebars located?", "snowblind"),
            "id" => $shortname."_sidebar_location",
			"default" => 1,
            "type" => "location"),
			
	array(  "name" => __("Sidebar Ads", "snowblind"),
			"desc" => __("Which sidebar would you like to display your side ads?", "snowblind"),
            "id" => $shortname."_sidebar_ads",
			"default" => "1",
            "type" => "sidebar-ads"),

	array(  "name" => __("Header Logo", "snowblind"),
			"desc" => __("If you would like to display a logo in the header, please enter the file path above.", "snowblind"),
            "id" => $shortname."_logo_header",
            "type" => "logo"),	
			
	array(  "name" => __("Logo or Blog Name Location", "snowblind"),
			"desc" => __("Where do you want your Logo or Blog Name located?", "snowblind"),
            "id" => $shortname."_logo_location",
			"default" => 1,
            "type" => "logo-location"),	

	array(  "name" => __("Pages", "snowblind"),
			"desc" => __("Which Pages would you like to include in the nav menu? Enter the Page IDs separated by commas or \"all\" to display all Pages.", "snowblind"),
            "id" => $shortname."_pages_include",
            "type" => "pages"),
			
	array(  "name" => __("Extended Footer", "snowblind"),
			"desc" => __("Would you like an extended footer?", "snowblind"),
            "id" => $shortname."_extended_footer",
			"default" => 1,
            "type" => "footer"),
			
	array(  "name" => __("Twitter Feed", "snowblind"),
			"desc" => __("Add your Twitter information above.", "snowblind"),
            "id" => $shortname."_twitter_username",
            "type" => "twitter"),	
			
	array(	"id" => $shortname."_twitter_num",
			"default" => "5"),	
			
	array(	"id" => $shortname."_twitter_link",
			"default" => __("Follow me on Twitter!", "snowblind")),			
	        
	array(  "name" => __("Site Description", "snowblind"),
			"desc" => __("Add a site description here. NOTE: Content is used as a description on individual posts and pages.", "snowblind"),
            "id" => $shortname."_site_description",
            "type" => "site-description"),

	array(  "name" => __("Keywords", "snowblind"),
			"desc" => __("Add site specific keywords here, separated by commas. NOTE: Tags are used as keywords on individual post pages.", "snowblind"),
            "id" => $shortname."_keywords",
            "type" => "keywords"),
				
	array(  "name" => __("Google Analytics", "snowblind"),
			"desc" => __("Add your Google Analytics code here.", "snowblind"),
            "id" => $shortname."_google_analytics",
            "type" => "google"),
			
	array(  "name" => __("Image Resizer", "snowblind"),
			"desc" => __("Would you like to have images automatically resized?", "snowblind"),
            "id" => $shortname."_image_resizer",
			"default" => "off",
            "type" => "resizer"),
	
	array(  "name" => __("Content or Excerpt", "snowblind"),
			"desc" => __("Would you like to display the content or the excerpt on your front page?", "snowblind"),
            "id" => $shortname."_content_excerpt",
			"default" => 1,
            "type" => "content-excerpt"),	
			
	array(  "name" => __("Content Image Resizer", "snowblind"),
			"desc" => __("Would you like to resize the images on your front page?", "snowblind"),
            "id" => $shortname."_content_resize",
			"default" => 1,
            "type" => "content-resize"),						
			
	array(  "name" => __("CSS", "snowblind"),
			"desc" => __("Add any CSS styles above. NOTE: Any modifications made to style.css directly will be overwritten when updating the theme so make your modifications here.", "snowblind"),
            "id" => $shortname."_css_styles",
            "type" => "css")								
);

add_action('admin_head', 'wp_admin_js');

function wp_admin_js() {
	global $themename;
	if(stristr($_REQUEST['page'], $themename)) { 
		echo '<link rel="stylesheet" href="'.get_bloginfo('template_url').'/admin/style.css" />';
		wp_enqueue_script("jquery");
		echo '<script type="text/javascript" src="'.get_bloginfo('template_url').'/admin/js/jquery.jqtransform.js" ></script>'."\n";
		echo '<link rel="stylesheet" href="'.get_bloginfo('template_url').'/admin/style.css" />';
		echo "
<script type=\"text/javascript\">
jQuery(document).ready(function(){
    jQuery(\"form.jqtransform\").jqTransform();
	jQuery(\"form.jqtransform\").fadeIn(500);
});
</script>
";
	}
	if(stristr($_REQUEST['page'], $themename.'-Header')) { 
		echo '<script type="text/javascript" src="'.get_bloginfo('template_url').'/admin/js/header.js"></script>'."\n"; 
	}
	if(stristr($_REQUEST['page'], $themename.'-Layout')) { 
		echo '<script type="text/javascript" src="'.get_bloginfo('template_url').'/admin/js/basic.js"></script>'."\n";
	}
}

function sil_head() {
// include the dynamic css styles
include('style.php'); 
}
add_action('wp_head', 'sil_head');

function mytheme_add_admin() {

    global $themename, $themefile, $shortname, $options;
    if (stristr($_REQUEST['page'], $themename)) {

        if ('save' == $_REQUEST['action']) {
				
			foreach ($options as $value) {
				if(!isset( $_REQUEST[ $value['id'] ]) ) {  } else { update_option( $value['id'], $_REQUEST[ $value['id'] ]  ); } }
			if(stristr($_SERVER['REQUEST_URI'],'&saved=true')) {
				$location = $_SERVER['REQUEST_URI'];
				} else {
				$location = $_SERVER['REQUEST_URI'] . "&saved=true";		
				}
								
			header("Location: $location");
			die;
        } 
    }
	// Set all default options
	foreach ($options as $default) {
		if(get_option($default['id'])=="") {
			update_option($default['id'],$default['default']);
		}
	}
	/*
	// Delete all default options
	foreach ($options as $default) {
		delete_option($default['id'],$default['default']);
	}
	*/	
	
	add_menu_page($themename, $themename, 10, $themename, $themefile);
	add_submenu_page($themename, "$themename - Info", __("Info", "snowblind"), 10, $themename, $themefile);
	add_submenu_page($themename, "$themename - Layout", __("Layout", "snowblind"), 10, $themename.'-Layout', 'sb_layout');
	add_submenu_page($themename, "$themename - Header", __("Header &amp; Footer", "snowblind"), 10, $themename.'-Header', 'sb_header');
	add_submenu_page($themename, "$themename - SEO", __("SEO", "snowblind"), 10, $themename.'-SEO', 'sb_seo');
	add_submenu_page($themename, "$themename - CSS", __("CSS", "snowblind"), 10, $themename.'-CSS', 'sb_css');
}

// HTML for top of admin pages
function admin_pages_top() {
?>
<form method="post" class="jqtransform" id="myForm" action="">
<div id="poststuff" class="metabox-holder has-right-sidebar">

<div id="side-info-column" class="inner-sidebar">
<div id='side-sortables' class='meta-box-sortables'>
<div id="linksubmitdiv" class="postbox " >
<h3><?php _e("Current Saved Settings", "snowblind"); ?></h3>
<div class="inside">
<div class="submitbox" id="submitlink">

<div id="minor-publishing">
	<ul style="padding:10px 0 0 5px;">
<?php
}

// HTML for middle of admin pages
function admin_pages_middle() {
?>
	</ul>
<div id="major-publishing-actions">

<div id="publishing-action">
	<input name="save" type="submit" value="<?php _e("Save Changes", "snowblind"); ?>" />    
	<input type="hidden" name="action" value="save" />
</div>
<div class="clear"></div>
</div>
<div class="clear"></div>
</div>

</div>
</div>
</div><a href="http://themes.bavotasan.com" target="_blank"><img src="<?php bloginfo('template_url'); ?>/admin/images/brand.png" class="bavota" alt="Designed by c.bavota" /></a></div></div>

<div id="post-body" class="has-sidebar">
<div id="post-body-content" class="has-sidebar-content">
<?php
}
######################################
## Display the info page ###
######################################

function snowblind() { 
     global $themename, $shortname, $options;
?>
<div class="wrap">
<h2><?php echo $themename." ".__("Settings", "snowblind")." - ".__("Info", "snowblind"); ?></h2>
<img src="<?php bloginfo('template_url'); ?>/admin/images/theme.png" alt="<?php echo $themename; ?>" class="theme" />
<?php
printf(__("<p>Thanks for downloading <strong>%s</strong>. Hope you enjoy using it!</p>
<p>There are tons of layout possibilities available with this theme, as well as a bunch of cool features that will surely help you get your site looking and working it's best.</p>", "snowblind"), $themename);
printf(__("<p>A lot of hard work went in to programming and designing <strong>%s</strong>, and if you would like to support c.bavota (the guy who built it) please use the donate link below. Any amount, even $1.00, is appreciated (a man's gotta eat, ya know).</p>", "snowblind"), $themename);
?>
<form action="https://www.paypal.com/cgi-bin/webscr" method="post">
<input type="hidden" name="cmd" value="_s-xclick" />
<input type="hidden" name="hosted_button_id" value="5745952" />
<input type="image" src="https://www.paypal.com/en_US/i/btn/btn_donateCC_LG.gif" name="submit" alt="PayPal - The safer, easier way to pay online!" />
<img alt="" src="https://www.paypal.com/en_US/i/scr/pixel.gif" width="1" height="1" />
</form>
<?php _e("<p>If you have any questions, comments, or if you encounter a bug, please visit our <a href=\"http://support.bavotasan.com/\">Support Forum</a>.</p>
", "snowblind"); ?>
<br style="clear: left;" />
<hr class="mbdotted" />
<h3 class="mbinstructions"><?php _e('INSTRUCTIONS', "snowblind"); ?></h3>
<p class="mbclear"><?php _e("<h4>1. Header Logo</h4>", "snowblind");
printf(__('To add a logo to the header, you need to upload the image through the WordPress uploader or through FTP. Once the image is uploaded, copy the file path, which should look like <code>http://www.yoursite.com/your-image.jpg</code>, and paste it into the <em>Header Logo</em> field on the <a href="admin.php?page=%1$s-Header">Header &amp; Footer</a> page.', "snowblind"), $themename); ?></p>
<?php _e("<h4>2. Image Resizer</h4>", "snowblind"); ?>
<p><?php _e('First, make sure to set the permissions of the cache folder in the theme\'s directory to 0755. Then turn on the Image Resizer on the <a href="admin.php?page=%1$s-Layout">Layout page</a>. ICropped images should now appear on your front page and category pages. If images only appear on the single post page, please go here to troubleshoot: <a href="http://code.google.com/p/timthumb/issues/detail?id=8">http://code.google.com/p/timthumb/issues/detail?id=8</a> or just keep the Image Resizer turned off.', "snowblind"); ?></p>
</div>

<?php 
}


######################################
## Display the layout options page ###
######################################

function sb_layout() { 
    global $themename, $shortname, $options;
?>
<div class="wrap">
<h2><?php echo $themename." ".__("Settings", "snowblind")." - ".__("Layout", "snowblind"); ?></h2>
<?php
if ( $_REQUEST['saved']) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' '.__("Settings Saved", "snowblind").'</strong></p></div>';
?>
<?php admin_pages_top(); // Display the HTML for the top of admin pages ?>
        <li><?php _e('Site Width', "snowblind"); ?>: <strong><?php echo get_option($shortname.'_site_width'); ?>px</strong></li>
        <li><?php _e('Number of Sidebars', "snowblind"); ?>: <strong><?php echo get_option($shortname.'_site_sidebars'); ?></strong></li>
        <li><?php _e('First Sidebar Width', "snowblind"); ?>: <strong><?php echo get_option($shortname.'_sidebar_width1'); ?>px</strong></li>
        <?php if (get_option($shortname.'_site_sidebars') == "2") { ?>
        <li><?php _e('Second Sidebar Width', "snowblind"); ?>: <strong><?php echo get_option($shortname.'_sidebar_width2'); ?>px</strong></li>
        <?php } ?>
        <li><?php _e('Sidebar Location', "snowblind"); ?>: <strong>
		<?php
			if(get_option($shortname.'_sidebar_location') == "1" || get_option($shortname.'_sidebar_location') == "2") {
				$barbar = true; 
			}
			if(get_option($shortname.'_site_sidebars') == "1" && $barbar != true) {
				echo "<span style='color:#ff0000;'>".__('Undefined', "snowblind")."</span>";
			} elseif(get_option($shortname.'_site_sidebars') == "2" && $barbar == true) { 
				echo "<span style='color:#ff0000;'>".__('Undefined', "snowblind")."</span>";
			} else {
				if(get_option($shortname.'_sidebar_location') == "3" || get_option($shortname.'_sidebar_location') == "1") { _e('Left', "snowblind"); } elseif(get_option($shortname.'_sidebar_location') == "2" || get_option($shortname.'_sidebar_location') == "4") { 
					_e('Right', "snowblind"); 
				} else {
					_e('Separate', "snowblind"); 
				}
			}
		?></strong></li>
        <li><?php _e("Image Resizer", "snowblind"); ?>: <strong><?php if(get_option($shortname.'_image_resizer') == 'on') { _e("Activated", "snowblind"); } else { _e("Off", "snowblind"); }  ?></strong></li>
        <li><?php _e("Content or Excerpt", "snowblind"); ?>: <strong><?php if(get_option($shortname.'_content_excerpt')==1) { _e("Content", "snowblind"); } else { _e("Excerpt", "snowblind"); } ?></strong></li>
        <?php if(get_option($shortname.'_content_excerpt')==1) { ?><li><?php _e("Content Image Resizer", "snowblind"); ?>: <strong><?php if(get_option($shortname.'_content_resize')==1) { _e("Yes", "snowblind"); } else { _e("No", "snowblind"); } ?></strong></li><?php }; ?>

<?php admin_pages_middle(); // Display the HTML for the middle of admin pages ?>
<?php
foreach ($options as $value) { 
	switch ( $value['type']) {

		case "site":
		?>
		<div class="stuffbox">
			<h3><?php echo $value['name']; ?></h3>
			<div class="inside">
                <input  name="<?php echo $value['id']; ?>" type="radio" value="800"<?php if(get_option( $value['id']) == "800") { echo " checked=\"checked\""; } ?> /><label>800px</label>
                <input  name="<?php echo $value['id']; ?>" type="radio" value="1024"<?php if(get_option( $value['id']) == "1024") { echo " checked=\"checked\""; } ?> /><label>1024px</label>
                <p style="clear:left;"><small><?php echo $value['desc']; ?></small></p>
			</div>
		</div>

		<?php 
		break;
		
		case "sidebars":
		?>
		<div class="stuffbox">
			<h3><?php echo $value['name']; ?></h3>
			<div class="inside">
                <input  name="<?php echo $value['id']; ?>" type="radio" value="1"<?php if(get_option( $value['id']) == "1") { echo " checked=\"checked\""; } ?> /><label>1</label>
                <input  name="<?php echo $value['id']; ?>" type="radio" value="2"<?php if(get_option( $value['id']) == "2") { echo " checked=\"checked\""; } ?> /><label>2</label>
                <p style="clear:left;"><small><?php echo $value['desc']; ?></small></p>
			</div>
		</div>
		<?php 
		break;
		
		case "left":
		?>
		<div id="leftWidth">
			<div class="stuffbox">
				<h3><?php echo $value['name']; ?></h3>
				<div class="inside">
                	<input  name="<?php echo $value['id']; ?>" type="radio" value="180"<?php if(get_option( $value['id']) == "180") { echo " checked=\"checked\""; } ?> /><label>180px</label>
                    <input  name="<?php echo $value['id']; ?>" type="radio" value="360"<?php if(get_option( $value['id']) == "360") { echo " checked=\"checked\""; } ?> /><label>360px</label>
					<p style="clear:left;"><small><?php echo $value['desc']; ?></small></p>
				</div>
			</div>
		</div>
		<?php
		break;
		   
		case "right":
		?>
		<div id="rightWidth">
			<div class="stuffbox">
				<h3><?php echo $value['name']; ?></h3>
				<div class="inside">
                	<input  name="<?php echo $value['id']; ?>" type="radio" value="180"<?php if(get_option( $value['id']) == "180") { echo " checked=\"checked\""; } ?> /><label>180px</label>
                    <input  name="<?php echo $value['id']; ?>" type="radio" value="360"<?php if(get_option( $value['id']) == "360") { echo " checked=\"checked\""; } ?> /><label>360px</label>
					<p style="clear:left;"><small><?php echo $value['desc']; ?></small></p>
				</div>
			</div>
		</div>           
		<?php
		break;

		case "location":
		?>
		<div class="stuffbox">
			<h3><?php echo $value['name']; ?></h3>
            <div class="inside">
                <div id="oneSidebar">
                    <table>
                        <tr>
                            <td style="padding-right: 15px;">
                                <img src="<?php bloginfo('template_url'); ?>/admin/images/oneleft.png" alt="" />
                            </td>
                            <td style="padding-right: 15px;">
                                <img src="<?php bloginfo('template_url'); ?>/admin/images/oneright.png" alt="" />
                            </td>
                        </tr>
                        <tr>
                            <td align="center" style="padding-right: 15px;">
                                <input  name="<?php echo $value['id']; ?>" id="oneleft" type="radio" value="1"<?php if(get_option( $value['id']) == "1") { echo " checked=\"checked\""; } ?> />
                            </td>
                            <td align="center" style="padding-right: 15px;">
                                <input  name="<?php echo $value['id']; ?>" type="radio" value="2"<?php if(get_option( $value['id']) == "2") { echo " checked=\"checked\""; } ?> />
                            </td>
                        </tr>
                    </table>
                </div>
                <div id="twoSidebar">
                    <table>
                        <tr>
                            <td style="padding-right: 15px;">
                                <img src="<?php bloginfo('template_url'); ?>/admin/images/twoleft.png" alt="" />
                            </td>
                            <td style="padding-right: 15px;">
                                <img src="<?php bloginfo('template_url'); ?>/admin/images/tworight.png" alt="" />
                            </td>
                            <td style="padding-right: 15px;">
                                <img src="<?php bloginfo('template_url'); ?>/admin/images/twoseparate.png" alt="" />
                            </td>
                        </tr>
                        <tr>
                            <td align="center" style="padding-right: 15px;">
                                <input  name="<?php echo $value['id']; ?>" id="twoleft" type="radio" value="3"<?php if(get_option( $value['id']) == "3") { echo " checked=\"checked\""; } ?> />
                            </td>
                            <td align="center" style="padding-right: 15px;">
                                <input  name="<?php echo $value['id']; ?>" type="radio" value="4"<?php if(get_option( $value['id']) == "4") { echo " checked=\"checked\""; } ?> />
                            </td>
                            <td align="center" style="padding-right: 15px;">
                                <input  name="<?php echo $value['id']; ?>" type="radio" value="5"<?php if(get_option( $value['id']) == "5") { echo " checked=\"checked\""; } ?> />
                            </td>
                        </tr>
                    </table>
                </div>
                <p style="clear:left;"><small><?php echo $value['desc']; ?></small></p>
			</div>
		</div>
		<?php break;		

		case "resizer":
		?>
        
		<div class="stuffbox">
			<h3><?php echo $value['name']; ?></h3>
			<div class="inside">
            	<input  name="<?php echo $value['id']; ?>" type="hidden" value="off" />
            	<input  name="<?php echo $value['id']; ?>" type="checkbox" <?php if(get_option($value['id']) == "on") { echo " checked=\"checked\""; } ?> /><label><?php _e('Activate Image Resizer', "snowblind"); ?></label>
			<p style="clear:left;"><small><?php echo $value['desc']; ?></small></p>
			</div>
		</div>
		<?php break;
		
		case "content-excerpt":
		?>
		<div class="stuffbox">
			<h3><?php echo $value['name']; ?></h3>
			<div class="inside">
                <input  name="<?php echo $value['id']; ?>" type="radio" value="1"<?php if(get_option( $value['id']) == 1) { echo " checked=\"checked\""; } ?> /><label><?php _e('Content', "snowblind"); ?></label>
                <input  name="<?php echo $value['id']; ?>" type="radio" value="2"<?php if(get_option( $value['id']) == 2) { echo " checked=\"checked\""; } ?> /><label><?php _e('Excerpt', "snowblind"); ?></label>
                <p style="clear:left;"><small><?php echo $value['desc']; ?></small></p>
			</div>
		</div>

		<?php 
		break;

		case "content-resize":
		?>
        <div class="stuffbox" id="content-resizer">
			<h3><?php echo $value['name']; ?></h3>
			<div class="inside">
                <input  name="<?php echo $value['id']; ?>" type="radio" value="1"<?php if(get_option( $value['id']) == 1) { echo " checked=\"checked\""; } ?> /><label><?php _e('Yes', "snowblind"); ?></label>
                <input  name="<?php echo $value['id']; ?>" type="radio" value="2"<?php if(get_option( $value['id']) == 2) { echo " checked=\"checked\""; } ?> /><label><?php _e('No', "snowblind"); ?></label>
                <p style="clear:left;"><small><?php echo $value['desc']; ?></small></p>
			</div>
		</div>

		<?php 
		break;
	} 
}
	?>
</div></div>
</div>
</form>
</div>
<?php
}

######################################
## Display the header options page ###
######################################

function sb_header() {
    global $themename, $themefile, $shortname, $options;
?>
<div class="wrap">
<h2><?php echo $themename." ".__("Settings", "snowblind")." - ".__("Header &amp; Footer", "snowblind"); ?></h2>
<?php
if ( $_REQUEST['saved']) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' '.__("Settings Saved", "snowblind").'</strong></p></div>';
?>
<?php admin_pages_top(); // Display the HTML for the top of admin pages ?>
        <li><?php _e('Header Logo', "snowblind"); ?>: <strong><?php if(get_option($shortname.'_logo_header')) { _e('Yes', "snowblind"); } else { _e('No', "snowblind"); } ?></strong></li>
        <li><?php _e('Logo or Name Location', "snowblind"); ?>: <strong><?php if(get_option($shortname.'_logo_location')==1) { _e('Left', "snowblind"); } elseif(get_option($shortname.'_logo_location')==2) { _e('Right', "snowblind"); } else { _e('Centered', "snowblind"); } ?></strong></li>
        <li><?php _e('Pages', "snowblind"); ?>: <strong><?php if(get_option($shortname.'_pages_include')) { _e('Added', "snowblind"); } else { echo '<span style="color:#ff0000;">'.__('Not Added', "snowblind").'</span>'; } ?></strong></li>
        <li><?php _e('Extended Footer', "snowblind"); ?>: <strong><?php if(get_option($shortname.'_extended_footer') == 1) { _e('Yes', "snowblind"); } else { _e('No', "snowblind"); } ?></strong></li>
        <?php if(get_option($shortname.'_extended_footer') == 1) { ?>
        <li><?php _e('Twitter Usernamer', "snowblind"); ?>: <strong><?php if(get_option($shortname.'_twitter_username')) { echo get_option($shortname.'_twitter_username'); } else { echo '<span style="color:#ff0000;">'.__("Not Added", "snowblind").'</span>'; } ?></strong></li>
        <li><?php _e('Number of Tweets', "snowblind"); ?>: <strong><?php if(get_option($shortname.'_twitter_num')) { echo get_option($shortname.'_twitter_num'); } else { echo '<span style="color:#ff0000;">'.__("Not Added", "snowblind").'</span>'; } ?></strong></li>
        <li><?php _e('Twitter Link', "snowblind"); ?>: <strong><?php if(get_option($shortname.'_twitter_link')) { echo get_option($shortname.'_twitter_link'); } else { echo '<span style="color:#ff0000;">'.__("Not Added", "snowblind").'</span>'; } ?></strong></li>
		<?php } ?>
<?php admin_pages_middle(); // Display the HTML for the middle of admin pages ?>
<?php
foreach ($options as $value) { 
	switch ( $value['type']) {

		case "logo":
		?>
		<div class="stuffbox">
			<h3><?php echo $value['name']; ?></h3>
			<div class="inside">
				<input type="text" size="50" name="<?php echo $value['id']; ?>" value="<?php echo get_option($value['id']); ?>" />
				<p style="clear:left;"><small><?php echo $value['desc']; ?></small></p>
                    <?php 
				  	$logofile = get_option($value['id']);
					if($logofile) { echo '<div><img src="'; echo $logofile; echo '" style="margin-top:10px;border:1px solid #aaa;padding:10px;" alt="" /></div>'; }
					?> 
	    	</div>
		</div>
		<?php
		break;
		
		case "logo-location":
		?>
		<div class="stuffbox">
			<h3><?php echo $value['name']; ?></h3>
			<div class="inside">
				<table>
					<tr>
						<td style="padding-right: 15px;">
							<img src="<?php bloginfo('template_url'); ?>/admin/images/logoleft.png" alt="" />
						</td>
						<td style="padding-right: 15px;">
							<img src="<?php bloginfo('template_url'); ?>/admin/images/logoright.png" alt="" />
						</td>
						<td style="padding-right: 15px;">
							<img src="<?php bloginfo('template_url'); ?>/admin/images/logomiddle.png" alt="" />
						</td>
					</tr>
					<tr>
						<td align="center" style="padding-right: 15px;">
							<input  name="<?php echo $value['id']; ?>" type="radio" value="1"<?php if(get_option( $value['id']) == "1") { echo " checked=\"checked\""; } ?> />
						</td>
						<td align="center" style="padding-right: 15px;">
							<input  name="<?php echo $value['id']; ?>" type="radio" value="2"<?php if(get_option( $value['id']) == "2") { echo " checked=\"checked\""; } ?> />
						</td>
						<td align="center" style="padding-right: 15px;">
							<input  name="<?php echo $value['id']; ?>" type="radio" value="3"<?php if(get_option( $value['id']) == "3") { echo " checked=\"checked\""; } ?> />
						</td>
					</tr>
				</table>
				<p style="clear:left;"><small><?php echo $value['desc']; ?></small></p>
			</div>
		 </div>
		<?php break;
		
		case "pages":
		?>
		<div class="stuffbox">
			<h3><?php echo $value['name']; ?></h3>
			<div class="inside">
            	<input type="text" name="<?php echo $value['id']; ?>" size="50" value="<?php echo get_option($value['id']); ?>" />
            	<p style="clear:left;"><small><?php echo $value['desc']; ?></small></p>
			</div>
		</div>
		<?php break;			
		
		case "footer":
		?>
		<div class="stuffbox">
			<h3><?php echo $value['name']; ?></h3>
			<div class="inside">
                <input  name="<?php echo $value['id']; ?>" type="radio" value="1"<?php if(get_option( $value['id']) == "1") { echo " checked=\"checked\""; } ?> /><label><?php _e('Yes', "snowblind"); ?></label>
                <input  name="<?php echo $value['id']; ?>" type="radio" value="0"<?php if(get_option( $value['id']) == "0") { echo " checked=\"checked\""; } ?> /><label><?php _e('No', "snowblind"); ?></label>
                <p style="clear:left;"><small><?php echo $value['desc']; ?></small></p>
			</div>
		</div>

		<?php 
		break;		
		
		case "twitter":
		?>
		<div class="stuffbox" id="twitter">
			<h3><?php echo $value['name']; ?></h3>
			<div class="inside">
				<table class="twitter">
                <tr><td><?php  _e('Twitter Username', "snowblind"); ?>:</td><td><input  name="<?php echo $value['id']; ?>" type="text" size="30" value="<?php echo get_option( $value['id']); ?>" /></td></tr>
				<tr><td><?php  _e('Number of Tweets', "snowblind"); ?>:</td><td><input  name="sil_twitter_num" type="text" size="5" value="<?php echo get_option('sil_twitter_num'); ?>" /></td></tr>
   				<tr><td><?php  _e('Twitter Link', "snowblind"); ?>:</td><td><input  name="sil_twitter_link" type="text" size="15" value="<?php echo get_option('sil_twitter_link'); ?>" /></td></tr>
                </table>
                <p style="clear:left;"><small><?php echo $value['desc']; ?></small></p>
			</div>
		</div>

		<?php 
		break;	
	}
}	
?>
</div></div>
</div></form>
</div>
<?php
}

########################################
## Display the seo options page ###
########################################

function sb_seo() {
   global $themename, $shortname, $options;
?>
<div class="wrap">
<h2><?php echo $themename." ".__("Settings", "snowblind")." - ".__("SEO", "snowblind"); ?></h2>
<?php
if ( $_REQUEST['saved']) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' '.__("Settings Saved", "snowblind").'</strong></p></div>';
?>
<?php admin_pages_top(); // Display the HTML for the top of admin pages ?>
        <li><?php _e('Site Description', "snowblind"); ?>: <strong><?php if(get_option($shortname.'_site_description')) { _e('Added', "snowblind"); } else { echo '<span style="color:#ff0000;">'.__('Not Added', "snowblind").'</span>'; } ?></strong></li>
        <li><?php _e('Keywords', "snowblind"); ?>: <strong><?php if(get_option($shortname.'_keywords')) { _e('Added', "snowblind"); } else { echo '<span style="color:#ff0000;">'.__('Not Added', "snowblind").'</span>'; } ?></strong></li>
        <li><?php _e('Google Analytics', "snowblind"); ?>: <strong><?php if(get_option($shortname.'_google_analytics')) { _e('Added', "snowblind"); } else { echo '<span style="color:#ff0000;">'.__('Not Added', "snowblind").'</span>'; } ?></strong></li>
<?php admin_pages_middle(); // Display the HTML for the middle of admin pages ?>

<?php
foreach ($options as $value) { 
	switch ( $value['type']) {

		case "site-description":
		?>
		<div class="stuffbox">
			<h3><?php echo $value['name']; ?></h3>
			<div class="inside">
            	<textarea name="<?php echo $value['id']; ?>" cols="60" rows="4"><?php echo stripslashes(get_option($value['id'])); ?></textarea>
				<p style="clear:left;"><small><?php echo $value['desc']; ?></small></p>
			</div>
		</div>
		<?php break;

		case "keywords":
		?>
		<div class="stuffbox">
			<h3><?php echo $value['name']; ?></h3>
			<div class="inside">
            	<textarea name="<?php echo $value['id']; ?>" cols="60" rows="6"><?php echo stripslashes(get_option($value['id'])); ?></textarea>
				<p style="clear:left;"><small><?php echo $value['desc']; ?></small></p>
			</div>
		</div>
		<?php break;

		case "google":
		?>
		<div class="stuffbox">
			<h3><?php echo $value['name']; ?></h3>
			<div class="inside">
            	<textarea name="<?php echo $value['id']; ?>" cols="60" rows="10"><?php echo stripslashes(get_option($value['id'])); ?></textarea>
				<p style="clear:left;"><small><?php echo $value['desc']; ?></small></p>
			</div>
		</div>
		<?php break;
	}
}
?>
</div></div>
</div>
</form>
</div>
<?php
}

########################################
## Display the css options page ###
########################################

function sb_css() {
    global $themename, $shortname, $options;
?>
<div class="wrap">
<h2><?php echo $themename." ".__("Settings", "snowblind")." - ".__("CSS", "snowblind"); ?></h2>
<?php
if ( $_REQUEST['saved']) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' '.__("Settings Saved", "snowblind").'</strong></p></div>';
?>
<?php admin_pages_top(); // Display the HTML for the top of admin pages ?>
        <li><?php _e('CSS', "snowblind"); ?>: <strong><?php if(get_option($shortname.'_css_styles')) { _e('Added', "snowblind"); } else { echo '<span style="color:#ff0000;">'.__("Not Added", "snowblind").'</span>'; } ?></strong></li>
<?php admin_pages_middle(); // Display the HTML for the middle of admin pages ?>

<?php
foreach ($options as $value) { 
	switch ( $value['type']) {

		case "css":
		?>
		<div class="stuffbox">
			<h3><?php echo $value['name']; ?></h3>
			<div class="inside">
            	<textarea name="<?php echo $value['id']; ?>" cols="60" rows="35"><?php echo stripslashes(get_option($value['id'])); ?></textarea>
				<p style="clear:left;"><small><?php echo $value['desc']; ?></small></p>
			</div>
		</div>
		<?php break;

	}
}
?>
</div></div>
</div>
</form>
</div>
<?php
}

add_action('admin_menu', 'mytheme_add_admin'); 

// include the twitter widget
include('widgets/widget_twitter.php'); 

// Initiating the siebars
if (function_exists("register_sidebar")) {
	register_sidebar(array(
		'name' => __('First Sidebar', "snowblind"),
		'before_widget' => '<div class="side-widget">',
		'after_widget' => '</div>',
		'before_title' => '<h2>',
		'after_title' => '</h2>',
	));
	
	if (get_option('sil_site_sidebars') == "2") {
		register_sidebar(array(
			'name' => __('Second Sidebar', "snowblind"),
			'before_widget' => '<div class="side-widget">',
			'after_widget' => '</div>',
			'before_title' => '<h2>',
			'after_title' => '</h2>',
		));
	}
	
	if (get_option('sil_extended_footer') == "1") {
		register_sidebar(array(
			'name' => __('Extended Footer', "snowblind"),
			'before_widget' => '<div class="bottom-widget">',
			'after_widget' => '</div>',
			'before_title' => '<h4>',
			'after_title' => '</h4>',
		));
	}
}

// Tags for keywords
function csv_tags() {
	global $shortname;
    $posttags = get_the_tags();
    if($posttags) {
		foreach((array)$posttags as $tag) {
			$csv_tags .= $tag->name . ',';
		}
	}
    echo '<meta name="keywords" content="'.$csv_tags.get_option($shortname.'_keywords').'" />';
}

// Meta description
function metaDesc() {
	global $shortname;
	$content = strip_tags(get_the_content());
	if($content) {
		$content = preg_replace('/\[.+\]/','', $content);
		$content = ereg_replace("[\n\r]", "\t", $content);
		$content = ereg_replace("\t\t+", " ", $content);
	} else {
		$content = get_option($shortname.'_site_description');
	}
	if (strlen($content) < 155) {
		echo $content;
	} else {
		$desc = substr($content,0,155);
		echo $desc."...";
	}
}

// Theme excerpts
function theme_excerpt($num=55) {
	$link = get_permalink();
	$limit = $num;
	$excerpt = explode(' ', strip_tags(get_the_excerpt()), $limit);
	if (count($excerpt)>=$limit) {
		array_pop($excerpt);
		$excerpt = implode(" ",$excerpt).'...';
	} else {
		$excerpt = implode(" ",$excerpt);
	}	
	$excerpt = apply_filters('the_content', $excerpt);
	$excerpt = preg_replace('`\[[^\]]*\]`','',$excerpt);
	echo '<p>'.$excerpt.'</p>';
}

// Theme contents
function theme_content($readmore) {
	$content = get_the_content($readmore);
	$content = strip_tags($content, '<a><strong><em><ul><li><embed><object>');
	$content = preg_replace('/\[.+\]/','', $content);
	$content = apply_filters('the_content', $content);
	$content = str_replace(']]>', ']]&gt;', $content);
	echo $content;
}

// resize function
function resize($w,$h,$q=80,$class='alignleft',$showlink=true) {
	global $more;
	$more = 1;
	$content = get_the_content();
	$title = get_the_title();
	$theme = get_bloginfo('template_url');
	if($showlink) {
		$link = "<a href='".get_permalink()."' title='$title'>";
		$linkend = "</a>";
	}
	$pattern = '/<img[^>]+src[\\s=\'"]';
	$pattern .= '+([^"\'>\\s]+)/is';
	if(preg_match($pattern,$content,$match)) {
		if(get_option('sil_image_resizer') == "on") { 
		echo "$link<img src=\"$theme/thumb.php?src=$match[1]&amp;h=$h&amp;w=$w&amp;zc=1&amp;q=$q\" class=\"$class\" alt=\"$title\" width=\"$w\" height=\"$h\" />$linkend"."\n\n";
		} else {
		echo "$link<img src=\"$match[1]\" class=\"$class\" alt=\"$title\" width=\"$w\" />$linkend"."\n\n";	
		}
	}
	$more = 0;
}

function popularPosts($num) {
    global $wpdb;

    $posts = $wpdb->get_results("SELECT comment_count, ID, post_title FROM $wpdb->posts ORDER BY comment_count DESC LIMIT 0 , $num");

    foreach ($posts as $post) {
        setup_postdata($post);
        $id = $post->ID;
        $title = $post->post_title;
        $count = $post->comment_count;

        if ($count != 0) {
            $popular .= '<li>';
            $popular .= '<a href="' . get_permalink($id) . '" title="' . $title . '">' . $title . '</a> ';
            $popular .= '</li>';
        }
    }
    return $popular;
}

// Comments
function mytheme_comment($comment, $args, $depth) {
   $GLOBALS['comment'] = $comment; ?>
   <li <?php comment_class(); ?> id="li-comment-<?php comment_ID() ?>">
     <div id="comment-<?php comment_ID(); ?>">
         <?php echo get_avatar($comment,$size='36'); ?>
         <span class="author"><?php echo get_comment_author_link(); ?></span><br />
      <span class="comment-meta"><a href="<?php echo htmlspecialchars(get_comment_link( $comment->comment_ID )) ?>">
<?php printf(__('%1$s at %2$s', "snowblind"), get_comment_date(),get_comment_time()) ?></a><?php edit_comment_link(__('(Edit)', "snowblind"),'  ','') ?></span>
      <?php if ($comment->comment_approved == '0') : ?>
         <em><?php _e('Your comment is awaiting moderation.', "snowblind") ?></em>
         <br />
      <?php endif; ?>
      <?php comment_text() ?>
		<?php if($args['max_depth']!=$depth) { ?>
      <div class="reply">
         <?php comment_reply_link(array_merge($args, array('depth' => $depth, 'max_depth' => $args['max_depth']))) ?>
      </div>
      <?php } ?>
     </div>
<?php
}

### Function: Page Navigation: Boxed Style Paging
function pagination($before = '', $after = '') {
	global $wpdb, $wp_query;
    pagenavi_init(); //Calling the pagenavi_init() function
	if (!is_single()) {
		$request = $wp_query->request;
		$posts_per_page = intval(get_query_var('posts_per_page'));
		$paged = intval(get_query_var('paged'));
		$pagenavi_options = get_option('pagenavi_options');
		$numposts = $wp_query->found_posts;
		$max_page = $wp_query->max_num_pages;
		if(empty($paged) || $paged == 0) {
			$paged = 1;
		}
		$pages_to_show = intval(10);
		$larger_page_to_show = intval($pagenavi_options['num_larger_page_numbers']);
		$larger_page_multiple = intval($pagenavi_options['larger_page_numbers_multiple']);
		$pages_to_show_minus_1 = $pages_to_show - 1;
		$half_page_start = floor($pages_to_show_minus_1/2);
		$half_page_end = ceil($pages_to_show_minus_1/2);
		$start_page = $paged - $half_page_start;
		if($start_page <= 0) {
			$start_page = 1;
		}
		$end_page = $paged + $half_page_end;
		if(($end_page - $start_page) != $pages_to_show_minus_1) {
			$end_page = $start_page + $pages_to_show_minus_1;
		}
		if($end_page > $max_page) {
			$start_page = $max_page - $pages_to_show_minus_1;
			$end_page = $max_page;
		}
		if($start_page <= 0) {
			$start_page = 1;
		}
		$larger_per_page = $larger_page_to_show*$larger_page_multiple;
		$larger_start_page_start = (n_round($start_page, 10) + $larger_page_multiple) - $larger_per_page;
		$larger_start_page_end = n_round($start_page, 10) + $larger_page_multiple;
		$larger_end_page_start = n_round($end_page, 10) + $larger_page_multiple;
		$larger_end_page_end = n_round($end_page, 10) + ($larger_per_page);
		if($larger_start_page_end - $larger_page_multiple == $start_page) {
			$larger_start_page_start = $larger_start_page_start - $larger_page_multiple;
			$larger_start_page_end = $larger_start_page_end - $larger_page_multiple;
		}
		if($larger_start_page_start <= 0) {
			$larger_start_page_start = $larger_page_multiple;
		}
		if($larger_start_page_end > $max_page) {
			$larger_start_page_end = $max_page;
		}
		if($larger_end_page_end > $max_page) {
			$larger_end_page_end = $max_page;
		}
		if($max_page > 1 || intval($pagenavi_options['always_show']) == 1) {
			$pages_text = str_replace("%CURRENT_PAGE%", number_format_i18n($paged), $pagenavi_options['pages_text']);
			$pages_text = str_replace("%TOTAL_PAGES%", number_format_i18n($max_page), $pages_text);
			echo $before.'<div class="pagination">'."\n";
			switch(intval($pagenavi_options['style'])) {
				case 1:
					if(!empty($pages_text)) {
						echo '<span class="pages">'.$pages_text.'</span>';
					}
					if ($start_page >= 2 && $pages_to_show < $max_page) {
						$first_page_text = str_replace("%TOTAL_PAGES%", number_format_i18n($max_page), $pagenavi_options['first_text']);
						echo '<a href="'.clean_url(get_pagenum_link()).'" class="first" title="'.$first_page_text.'">'.$first_page_text.'</a>';
						if(!empty($pagenavi_options['dotleft_text'])) {
							echo '<span class="extend">'.$pagenavi_options['dotleft_text'].'</span>';
						}
					}
					if($larger_page_to_show > 0 && $larger_start_page_start > 0 && $larger_start_page_end <= $max_page) {
						for($i = $larger_start_page_start; $i < $larger_start_page_end; $i+=$larger_page_multiple) {
							$page_text = str_replace("%PAGE_NUMBER%", number_format_i18n($i), $pagenavi_options['page_text']);
							echo '<a href="'.clean_url(get_pagenum_link($i)).'" class="page" title="'.$page_text.'">'.$page_text.'</a>';
						}
					}
					previous_posts_link($pagenavi_options['prev_text']);
					for($i = $start_page; $i  <= $end_page; $i++) {						
						if($i == $paged) {
							$current_page_text = str_replace("%PAGE_NUMBER%", number_format_i18n($i), $pagenavi_options['current_text']);
							echo '<span class="current">'.$current_page_text.'</span>';
						} else {
							$page_text = str_replace("%PAGE_NUMBER%", number_format_i18n($i), $pagenavi_options['page_text']);
							echo '<a href="'.clean_url(get_pagenum_link($i)).'" class="page" title="'.$page_text.'">'.$page_text.'</a>';
						}
					}
					next_posts_link($pagenavi_options['next_text'], $max_page);
					if($larger_page_to_show > 0 && $larger_end_page_start < $max_page) {
						for($i = $larger_end_page_start; $i <= $larger_end_page_end; $i+=$larger_page_multiple) {
							$page_text = str_replace("%PAGE_NUMBER%", number_format_i18n($i), $pagenavi_options['page_text']);
							echo '<a href="'.clean_url(get_pagenum_link($i)).'" class="page" title="'.$page_text.'">'.$page_text.'</a>';
						}
					}
					if ($end_page < $max_page) {
						if(!empty($pagenavi_options['dotright_text'])) {
							echo '<span class="extend">'.$pagenavi_options['dotright_text'].'</span>';
						}
						$last_page_text = str_replace("%TOTAL_PAGES%", number_format_i18n($max_page), $pagenavi_options['last_text']);
						echo '<a href="'.clean_url(get_pagenum_link($max_page)).'" class="last" title="'.$last_page_text.'">'.$last_page_text.'</a>';
					}
					break;
				case 2;
					echo '<form action="'.htmlspecialchars($_SERVER['PHP_SELF']).'" method="get">'."\n";
					echo '<select size="1" onchange="document.location.href = this.options[this.selectedIndex].value;">'."\n";
					for($i = 1; $i  <= $max_page; $i++) {
						$page_num = $i;
						if($page_num == 1) {
							$page_num = 0;
						}
						if($i == $paged) {
							$current_page_text = str_replace("%PAGE_NUMBER%", number_format_i18n($i), $pagenavi_options['current_text']);
							echo '<option value="'.clean_url(get_pagenum_link($page_num)).'" selected="selected" class="current">'.$current_page_text."</option>\n";
						} else {
							$page_text = str_replace("%PAGE_NUMBER%", number_format_i18n($i), $pagenavi_options['page_text']);
							echo '<option value="'.clean_url(get_pagenum_link($page_num)).'">'.$page_text."</option>\n";
						}
					}
					echo "</select>\n";
					echo "</form>\n";
					break;
			}
			echo '</div>'.$after."\n";
		}
	}
}

### Function: Round To The Nearest Value
function n_round($num, $tonearest) {
   return floor($num/$tonearest)*$tonearest;
}

### Function: Page Navigation Options
add_action('activate_wp-pagenavi/wp-pagenavi.php', 'pagenavi_init');
function pagenavi_init() {
	//pagenavi_textdomain();
	// Add Options
	$pagenavi_options = array();
	$pagenavi_options['pages_text'] = __('Page %CURRENT_PAGE% of %TOTAL_PAGES%',"snowblind");
	$pagenavi_options['current_text'] = '%PAGE_NUMBER%';
	$pagenavi_options['page_text'] = '%PAGE_NUMBER%';
	$pagenavi_options['first_text'] = __('&laquo; First',"snowblind");
	$pagenavi_options['last_text'] = __('Last &raquo;',"snowblind");
	$pagenavi_options['next_text'] = __('&raquo;',"snowblind");
	$pagenavi_options['prev_text'] = __('&laquo;',"snowblind");
	$pagenavi_options['dotright_text'] = __('...',"snowblind");
	$pagenavi_options['dotleft_text'] = __('...',"snowblind");
	$pagenavi_options['style'] = 1;
	$pagenavi_options['num_pages'] = 10;
	$pagenavi_options['always_show'] = 0;
	$pagenavi_options['num_larger_page_numbers'] = 3;
	$pagenavi_options['larger_page_numbers_multiple'] = 10;
	add_option('pagenavi_options', $pagenavi_options, 'PageNavi Options');
}
?>